// THE HOVGAARD KLAN
// PROJECT: HOVTEXT
//---------------------------------------------------------------------------

#include <vcl.h>
#include <vcl\Clipbrd.hpp>
#pragma hdrstop            
#include <string>
#include <cstring>
#include <sstream>
#include <algorithm>
#include <boost/regex.hpp>


#include "ClipForm.h"
#include "about.h"
#include "lang.h"
#include "setup.h"
#include "winutil.h"
#include "filetypes.h"
#include "tipform.h"
#include "getmod.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TClipForm1 *ClipForm1;                   


//---------------------------------------------------------------------------
// TClipForm1
//---------------------------------------------------------------------------

__fastcall TClipForm1::TClipForm1(TComponent* Owner)
		  : TForm(Owner), History(10),HisPut(0), HisGet(0), HisMax(10)
{
  ConvertOnCopy=false;
  memset(HotKeySet,0 , sizeof HotKeySet);
  Hide();
  if (FileExists("active.ico"))
     ImageActive->Picture->Icon->LoadFromFile("active.ico");
  if (FileExists("inactive.ico"))
     ImageInactive->Picture->Icon->LoadFromFile("inactive.ico");
  if (FileExists("hotkey.ico"))
     ImageHotkey->Picture->Icon->LoadFromFile("hotkey.ico");
  TrayIcon_Create ((AnsiString("HovText - ") + LangText(TE_Active)).c_str(),ImageActive->Picture->Icon->Handle);
  if (GetRegInt("StartAs")==2) {
    SetActive(GetRegInt("LastState"));
  } else
  {
    SetActive(GetRegInt("StartAs")==0);
  }
  StripWS=GetRegInt("StripWS");
  StripCR=GetRegInt("StripCR");
  RemoveDoubles=GetRegInt("UniqueLines");
  OnlyCopyLinks=GetRegInt("OnlyCopyLinks");
  FileTypes.Select(GetRegInt("CopyLinkType"));
  CF_HTML  = RegisterClipboardFormat("HTML Format");
  CF_EXCEL = RegisterClipboardFormat("Biff8");
  CF_RICHTEXT  = RegisterClipboardFormat("Rich Text Format");
  m_hWndClipChain  =  ::SetClipboardViewer( Handle );
  LangNotifier.AddLangNotify(this);
  LangChange();

}


void TClipForm1::LangChange()
{
 Active1->Caption=LangText(TE_Active);
 Exit1->Caption=LangText(TE_Exit);
 About1->Caption=LangText(TE_About);
 Options1->Caption=LangText(TE_Options);
 SetActive(Active1->Checked);
}

__fastcall TClipForm1::~TClipForm1()
{
 ChangeClipboardChain(Handle, m_hWndClipChain );
 UnsetHotKey(1);
 UnsetHotKey(2);
 TrayIcon_Delete();
}


//---------------------------------------------------------------------------

void __fastcall TClipForm1::WMChangeCBChain( TWMChangeCBChain& Message )
{
  if( m_hWndClipChain == Message.Remove )
    m_hWndClipChain = Message.Next;
  else if( m_hWndClipChain )
    ::SendMessage( m_hWndClipChain, WM_CHANGECBCHAIN,    (WPARAM)Message.Remove, (LPARAM)Message.Next );
}

void __fastcall TClipForm1::WMDrawClipboard( TWMDrawClipboard& Message)
{
  static Saving=false;

  if (Saving) return ;
  Saving=true;
  HWND hOwner = GetClipboardOwner();
  if (hOwner != Handle) {
    bool IgnoreApp=false;
    AnsiString ExeName=ModuleNameFromHWnd(hOwner);
    ExeName=ExeName.UpperCase();
    if (ExeName=="WINVNC")     IgnoreApp=true;

    if ((!IgnoreApp) && OpenClipboard(Handle))
    {
      if (IsClipboardFormatAvailable(CF_TEXT) && GetRegInt("History") )
      {
        TSaveClipbd clip;
        if (SaveClipboard(clip))
        {
          short HisPutLast=HisPut-1;
          if (HisPutLast<0)
            HisPutLast=HisMax-1;
          if (!CmpSaveClipboardText(History[HisPutLast], clip))
          {
              CopySaveClipboard(clip, History[HisPut]);
              ClrSaveClip(clip);
              HisGet=HisPut;
              if (++HisPut>=HisMax) HisPut=0;
          }
        }
      }
      if (ConvertOnCopy)
        ConvertClip();

      if( m_hWndClipChain )
        ::SendMessage( m_hWndClipChain, WM_DRAWCLIPBOARD, 0, 0 );
      Sleep(5);

      CloseClipboard();
    }
  }
  Saving=false;
}



//-----------------------------------------------------------------------

void _fastcall TClipForm1::ClrSaveClip(TSaveClipbd &SaveClip)
{
  for (unsigned i=0;i<SaveClip.size();i++)
    delete SaveClip[i].data;
  SaveClip.clear();
}

std::string _fastcall TClipForm1::SaveClipText(const TSaveClipbd &SaveClip)
{
  std::string s;
  for (unsigned i=0;i<SaveClip.size();i++)
  {
    s+=SaveClip[i].intro;
  }
  return s;
}

void _fastcall TClipForm1::CopySaveClipboard(const TSaveClipbd &cbfrom, TSaveClipbd &cbto)
{
  ClrSaveClip(cbto);
  for (unsigned i=0;i<cbfrom.size();i++)
  {
    TSaveFmt s;
    s.fmt  = cbfrom[i].fmt;
    s.size = cbfrom[i].size;
    s.name = cbfrom[i].name;
    s.intro= cbfrom[i].intro;
    s.data = new char[s.size];
    memcpy(s.data, cbfrom[i].data, s.size);
    cbto.push_back(s);
  }
}

bool _fastcall TClipForm1::CmpSaveClipboardText(const TSaveClipbd &cb1, const TSaveClipbd &cb2)
{
  short txt1=-1, txt2=-1;
  for (unsigned i=0;i<cb1.size();i++)
    if (cb1[i].fmt==CF_TEXT) txt1=i;
  for (unsigned i=0;i<cb2.size();i++)
    if (cb2[i].fmt==CF_TEXT) txt2=i;
  if (txt1!=-1 && txt2!=-1 && cb1[txt1].size == cb2[txt2].size)
    return 0==memcmp(cb1[txt1].data, cb2[txt2].data, cb2[txt2].size);
  else
    return false;
}




bool _fastcall TClipForm1::SaveClipboard(TSaveClipbd &SaveClip)
{
  char name[200];
  bool ok=false;

  ClrSaveClip(SaveClip);
  UINT Format=EnumClipboardFormats(0);
  while (Format)
  {
    if ( ((Format<CF_PRIVATEFIRST) || (Format > CF_PRIVATELAST)) &&
        GetClipboardFormatName(Format, name, sizeof name))
    {
      if (RegClipFmt.count(name)==0)
      {
        RegisterClipboardFormat(name);
        RegClipFmt.insert(name);
      }
    }
    Format=EnumClipboardFormats(Format);
  }

  bool IsExcelClip= IsClipboardFormatAvailable(CF_EXCEL);
  Format=EnumClipboardFormats(0);
  while (Format)
  {
    TSaveFmt s;
    s.fmt=Format;

    bool SkipFmt=false;
    if (IsExcelClip  &&   s.fmt!=CF_TEXT )
       SkipFmt=true;

    if (!SkipFmt)
    {
      HANDLE HClip = GetClipboardData(s.fmt);

      if (HClip !=NULL)
        s.size=GlobalSize((HGLOBAL)HClip);
      else
        s.size=0;

      if (s.size!=0)
      {
        void *from=GlobalLock((HGLOBAL)HClip);
        s.data=new char[s.size];
        if (from!=NULL)
        {
          memcpy(s.data, from, s.size);
          if (s.fmt==CF_TEXT)
          {
            char text[600];
            char *startpos=(char*)s.data;
            while ( *startpos=='\n' || *startpos=='\r'
                    || *startpos=='\t' || *startpos==' ')
              startpos++;
            strncpy(text,(char *) startpos, std::min(600,s.size));
            text[599]=0;
            s.intro=text;
          }
          GlobalUnlock((HGLOBAL)HClip);
          SaveClip.push_back(s);
          ok=true;
        }
      }
    }
    Format=EnumClipboardFormats(Format);
  }
  return ok;
}


bool _fastcall TClipForm1::RestoreClipboard(const TSaveClipbd &SaveClip, bool onlytext)
{
  bool result=false;
  if (OpenClipboard(Handle))
  {
    if (EmptyClipboard())
    {
      for (unsigned i=0;i<SaveClip.size();i++) {
        if ((SaveClip[i].fmt==CF_TEXT) || (!onlytext) )
        {
          HANDLE h=GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, SaveClip[i].size);
          void *data=GlobalLock(h);
          if (data !=NULL)
          {
            memcpy(data,SaveClip[i].data, SaveClip[i].size);
            GlobalUnlock(h);
            SetClipboardData(SaveClip[i].fmt, h);
            result=true;
          }
        }
      }
    }
    CloseClipboard();
  }
  return result;
}

bool TClipForm1::HasFmt(TSaveClipbd cb1, UINT fmt)
{
   for (unsigned i=0;i<cb1.size();i++)
     if (cb1[i].fmt==fmt) return true;
   return false;
}
void * TClipForm1::GetFmt(TSaveClipbd cb1, UINT fmt)
{
   for (unsigned i=0;i<cb1.size();i++)
     if (cb1[i].fmt==fmt) return cb1[i].data;
   return NULL;
}
long TClipForm1::GetFmtSize(TSaveClipbd cb1, UINT fmt)
{
   for (unsigned i=0;i<cb1.size();i++)
     if (cb1[i].fmt==fmt) return cb1[i].size;
   return 0;
}



bool _fastcall TClipForm1::ConvertSavedClipboard(const TSaveClipbd &Clip, std::string &resultstring)
{
  bool ok=false;
  std::rope <char> result;
  if (OnlyCopyLinks)
  {
    if (HasFmt(Clip, CF_HTML) || HasFmt(Clip, CF_TEXT))
    {
      std::string HTML;
      if (HasFmt(Clip, CF_HTML)) {
        HTML = (char*)GetFmt(Clip, CF_HTML);
        size_t i=HTML.find_first_of("StartFragment");
        while (i<HTML.length() && HTML[i]!='>') i++;
        HTML.erase(0,i);
      } else
        HTML = (char*)GetFmt(Clip, CF_TEXT);
      try
      {
        if (!FileTypes[FileTypes.Selected()].RegEx())
        {
          size_t i=0;
          while (i<HTML.length())
          {
            if ( (HTML[i]!='.') && (HTML[i+1]=='h') && (HTML[i+2]=='r') && (HTML[i+3]=='e')
                && (HTML[i+4]=='f') && (HTML[i+5]=='='))
            {
              i+=6;
              if ((HTML[i]=='\'') || (HTML[i]=='"'))
                i++;
              long startpos=i;
              while ((i<HTML.length()) && (HTML[i]!='\'') && (HTML[i]!='"') && (HTML[i]!='>'))
                i++;
              if ((HTML.substr(startpos,4)!="java")
                  && (HTML.substr(startpos,4)!="Java")
                  && (HTML.substr(startpos,4)!="JAVA")
                  && (HTML[startpos]!='#')
                  && (HTML[startpos]!='?')
                  && (HTML[startpos]!='/')
                  && (HTML[startpos]!='\\')
                  )
              {
                std::string link;

                link=HTML.substr(startpos, i-startpos);
                if ((link.size()>0) && FileTypes.Match(link))
                {
                  if (link.substr(0,10)=="mailto:%20")
                     link = link.substr(10, 999);
                  else if (link.substr(0,7)=="mailto:")
                     link=link.substr(7, 999);
                  result += link.c_str();
                  result += "\r\n";
                }
              }
            }
            i++;
          }
        } else {

          std::vector<std::string> re;
          FileTypes.GetStrs(re);


          for (unsigned i=0;i<re.size();i++)
          {
            boost::regex expression(re[i],
                               boost::regbase::normal | boost::regbase::icase);

            std::string::const_iterator start, end;
            start = HTML.begin();
            end = HTML.end();
            boost::match_results<std::string::const_iterator> what;
            boost::match_flag_type flags = boost::match_default;
            while(regex_search(start, end, what, expression, flags))
            {
              result +=  std::string(what[1].first, what[1].second).c_str();
              result += "\r\n";

              start = what[1].second;
              // update flags:
              flags |= boost::match_prev_avail;
              flags |= boost::match_not_bob;
            }
          }
        }
        ok=true;
      }
      catch (...) {

      }
    }
  } else if (HasFmt(Clip, CF_TEXT))
  {
    result = (char *) GetFmt(Clip, CF_TEXT);
    if  (StripWS || StripCR)
    {
       while ( result.size()>0 && ((StripWS && (result.front()==' ' || result.front()=='\t')) ||
                (StripCR && (result.front()=='\n' || result.front()=='\r')) )

                )
         result.pop_front();;

       while ( result.size()>0  && ( ((StripWS && (result.back()==' ' || result.back()=='\t')) ||
                  (StripCR && (result.back()=='\n' || result.back()=='\r')) ))
              )
         result.pop_back();;
    }
    ok=true;
  }
  
  if (RemoveDoubles)
  {
    std::vector<std::string> UniqueLines;
    std::istringstream  is(result.c_str());
    std::string s;
    while (is)
    {
       getline(is, s);
       while (*(s.end()-1) == '\r' || *(s.end()-1) == '\n')
         s.pop_back();
       s+="\r\n";
       std::vector<std::string>::iterator it =
            find(UniqueLines.begin(), UniqueLines.end(), s);
       if (it == UniqueLines.end())
         UniqueLines.push_back(s);
     }
     resultstring=accumulate(UniqueLines.begin(),UniqueLines.end(),std::string("")).c_str();
  } else
    resultstring=result.c_str();

  return ok;
}


bool __fastcall TClipForm1::ConvertedClipboard(std::string &result)
{
  if (OpenClipboard(Handle))
  {
    SaveClipboard(GlobalSaveClip);
    return ConvertSavedClipboard(GlobalSaveClip, result);
	}
  return false;
}


bool __fastcall TClipForm1::ConvertClip()
{
  bool converted=false, HasText=false;

  if (OpenClipboard(Handle))
  {
    HasText=IsClipboardFormatAvailable(CF_TEXT);
    CloseClipboard();
  }

  if (HasText ) {
     std::string result;
     if (ConvertedClipboard(result))
     {
        SetTextClipboard(result.c_str());
        converted=true;
     }
  }
  return converted;
}

bool TClipForm1::SetTextClipboard(const char *text)
{
  bool result=false;
  size_t len=strlen(text)+1;
  HGLOBAL HTextCF = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, len);
  void *to=GlobalLock(HTextCF);
  if (to!=NULL )
  {
    memcpy(to,text,len);
    GlobalUnlock(HTextCF);
    if (OpenClipboard(Handle))
    {
      if (EmptyClipboard())
      {
        SetClipboardData(CF_TEXT, HTextCF);
        result=true;
      }
      CloseClipboard();
    }
  }
  return result;
}


//---------------------------------------------------------------------------
// TrayIcon Functions:
//---------------------------------------------------------------------------

void TClipForm1::TrayIcon_Create (const char *tipText,HICON hIcon)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize          =sizeof(info) ;
  info.hWnd            =Handle;
  info.uID             =WM_TRAY_ICON_ID;
  info.uCallbackMessage=WM_TRAY_ICON_MESSAGE;
  info.hIcon           =hIcon;
  strncpy (info.szTip,tipText,sizeof(info.szTip));
  info.szTip[sizeof(info.szTip)-1]='0';
  info.uFlags          =NIF_MESSAGE | NIF_ICON | NIF_TIP ;
  Shell_NotifyIcon(NIM_ADD,&info) ;
}


//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_ModifyTip(const char *tipText)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize          =sizeof(info) ;
  info.hWnd            =Handle;
  info.uID             =WM_TRAY_ICON_ID;
  info.uFlags          =NIF_TIP;
  strncpy(info.szTip,tipText,sizeof(info.szTip));
  info.szTip[sizeof(info.szTip)-1]='\0';
  Shell_NotifyIcon(NIM_MODIFY,&info);
}
//---------------------------------------------------------------------------

void TClipForm1::TrayIcon_ShowBalloonTip(const char *szMsg,
  const char *szTitle, unsigned uTimeout, long dwInfoFlags)
{
  NOTIFYICONDATA info;
  info.cbSize=sizeof(NOTIFYICONDATA);
  info.uFlags = NIF_INFO;
  info.uTimeout = uTimeout;
  info.dwInfoFlags = dwInfoFlags;
  std::strcpy(info.szInfo,szMsg ? szMsg : "");
  std::strcpy(info.szInfoTitle,szTitle ? szTitle : _T(""));
  Shell_NotifyIcon(NIM_MODIFY, &info);
}
//---------------------------------------------------------------------------


void TClipForm1::TrayIcon_ModifyIcon(HICON hIcon)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize          =sizeof(info) ;
  info.hWnd            =Handle;
  info.uID             =WM_TRAY_ICON_ID;
  info.hIcon           =hIcon;
  info.uFlags          =NIF_ICON;
  Shell_NotifyIcon(NIM_MODIFY,&info) ;
}
//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_Delete(void)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize=sizeof(info);
  info.hWnd  =Handle;
  info.uID   =WM_TRAY_ICON_ID;
  Shell_NotifyIcon(NIM_DELETE,&info);
}
//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_HandleMessage(TMessage &Message)
{
  switch (Message.LParam)
  {
    case WM_LBUTTONDBLCLK:
      if (!((AboutBox->Visible) || (SetupForm->Visible)))
      {
       SetForegroundWindow(Handle);
       Active1Click(this);
       Options1Click(this);
      } else if (SetupForm->Visible && !SetupForm->Focused())
      {
       SetForegroundWindow(Handle);
       SetupForm->SetFocus();
      } else if (AboutBox->Visible && !AboutBox->Focused())
      {
       SetForegroundWindow(AboutBox->Handle);
       AboutBox->SetFocus();
      }
    break;
    case WM_LBUTTONUP:
    case WM_MBUTTONUP:
      if (!SetupForm->Visible)
      {
        Active1Click(this);
      }
    break;
    case WM_RBUTTONDOWN:
      if (!((AboutBox->Visible) || (SetupForm->Visible)))
      {
        POINT point;
        HWND Prev;
        ::GetCursorPos(&point);
        SetForegroundWindow(Handle);

        PopupMenu1->Popup(point.x,point.y);
        Prev= GetForegroundWindow();
        SetForegroundWindow(Handle);
        SetForegroundWindow(Prev);
      }
    break;
    case WM_RBUTTONDBLCLK:
    case WM_MOUSEMOVE:
    case WM_LBUTTONDOWN:
    break;
  }
}
//---------------------------------------------------------------------------
// Menu Functions:
//---------------------------------------------------------------------------

void __fastcall TClipForm1::Exit1Click(TObject *Sender)
{
  RestoreClipboard(GlobalSaveClip);
  ClrSaveClip(GlobalSaveClip);
	Close();
}


//---------------------------------------------------------------------------

void __fastcall TClipForm1::ChangeIcons(short set)
{
  ImageActive->Picture->Icon=AltImageActive->Picture->Icon;
  ImageInactive->Picture->Icon=AltImageInactive->Picture->Icon;
  ImageHotkey->Picture->Icon=AltImageHotkey->Picture->Icon;
  SetActive(Active1->Checked);
}


void __fastcall TClipForm1::SetActive(bool active)
{
  Active1->Checked=active;
  ConvertOnCopy=false;
  if (active)
  {
    if (GetRegInt("HotKeyFunction")) {
      TrayIcon_ModifyTip((AnsiString("HovText - ") + LangText(TE_Hotkey)).c_str());
      TrayIcon_ModifyIcon(ImageHotkey->Picture->Icon->Handle);
    } else {
      TrayIcon_ModifyTip((AnsiString("HovText - ") + LangText(TE_Active)).c_str());
      TrayIcon_ModifyIcon(ImageActive->Picture->Icon->Handle);
      ConvertOnCopy=true;
      std::string result;
      if (ConvertSavedClipboard(GlobalSaveClip, result))
        SetTextClipboard(result.c_str());
    }
  }
  else
  {
    TrayIcon_ModifyTip((AnsiString("HovText - ") + LangText(TE_Inactive)).c_str());
    TrayIcon_ModifyIcon(ImageInactive->Picture->Icon->Handle);
    RestoreClipboard(GlobalSaveClip);
  }
  if (GetRegInt("StartAs")==2) 
    SetRegInt("LastState",Active1->Checked);
}

void __fastcall TClipForm1::Active1Click(TObject *Sender)
{
  SetActive(!Active1->Checked);
}

//---------------------------------------------------------------------------

void __fastcall TClipForm1::About1Click(TObject *Sender)
{
  AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TClipForm1::Options1Click(TObject *Sender)
{
  UnsetHotKey(1);
  UnsetHotKey(2);
  if (SetupForm->ShowModal()==mrOk)
  {
  }
  StripWS=GetRegInt("StripWS");
  StripCR=GetRegInt("StripCR");
  RemoveDoubles=GetRegInt("UniqueLines");
  OnlyCopyLinks=GetRegInt("OnlyCopyLinks");
  FileTypes.Select(GetRegInt("CopyLinkType"));
  SetHotKey(1, "HotKey");
  if (GetRegInt("History"))
    SetHotKey(2, "HistoryHotKey");
  else
    UnsetHotKey(2);
  SetActive(Active1->Checked);
}
//---------------------------------------------------------------------------


void __fastcall TClipForm1::SetHotKey(int Nr, AnsiString name)
{
  Word TheKey;
  TShiftState TheShiftState;
  UnsetHotKey(Nr);
  ShortCutToKey((Classes::TShortCut) GetRegInt(name), TheKey, TheShiftState);
  if (TheKey!=0)
  {
     unsigned fsMod=0;
     if (TheShiftState.Contains(ssShift)) fsMod |= MOD_SHIFT;
     if (TheShiftState.Contains(ssCtrl)) fsMod |= MOD_CONTROL;
     if (TheShiftState.Contains(ssAlt)) fsMod |= MOD_ALT;
     RegisterHotKey(Handle, Nr, fsMod, TheKey);
     HotKeySet[Nr]=true;
   }
}

void __fastcall TClipForm1::UnsetHotKey(int Nr)
{
  if (HotKeySet[Nr])
     UnregisterHotKey( Handle, Nr );
  HotKeySet[Nr]=false;
}

void __fastcall TClipForm1::WMHotKey(TMessage &Message)
{
  int id=Message.WParam;
  switch (id)
  {
    case 1:
      if (GetRegInt("HotKeyFunction")){
         ConvertClip();
      } else
         Active1Click(this);
    break;
    case 2:
    {
      if (!TipWin->Visible)
        HisGet=HisPut;
      HisGet--;
      if (HisGet<0) HisGet=HisMax-1;
      if (History[HisGet].size()==0)
      {
        HisGet=HisPut-1;
        if (HisGet<0) HisGet=HisMax-1;
      }
      short HisNext=HisGet-1;
      if (HisNext<0) HisNext=HisMax-1;
      if (History[HisGet].size()>0)
      {
        TSaveClipbd cbtemp;
        CopySaveClipboard(History[HisGet], cbtemp);
        CopySaveClipboard(History[HisGet], GlobalSaveClip);
        int ms=GetRegInt("HistoryTime");
        bool Last=History[HisNext].size()==0 || HisGet==HisPut;
        TipWin->ShowTip(SaveClipText(History[HisGet]).c_str(),
                         GetRegInt("HistoryLines"),
                         ms, Last);
        if (Active1->Checked)
        {
          std::string result;
          if (ConvertSavedClipboard(cbtemp, result))
            SetTextClipboard(result.c_str());

        } else
          RestoreClipboard(cbtemp);
        ClrSaveClip(cbtemp);
      } else
        HisGet=(HisGet+1)%HisMax;
    }
    break;
  }
}



void __fastcall TClipForm1::SetupTimerTimer(TObject *Sender)
{
 SetupTimer->Enabled=false;
 SetHotKey(1, "HotKey");
 if (GetRegInt("History"))
   SetHotKey(2, "HistoryHotKey");

   if (GetRegInt("WelcomeShown")==0)
   {
      Application->MessageBox(LangText(TE_WelcomeText).c_str(),
                              LangText(TE_WelcomeCaption).c_str() ,MB_OK);
      SetRegInt("WelcomeShown",1);
      SetForegroundWindow(Handle);
      Options1Click(this);
   }

}
//---------------------------------------------------------------------------




