// THE HOVGAARD KLAN
// PROJECT: HOVTEXT
//---------------------------------------------------------------------------


#pragma hdrstop

#include "lang.h"
#include "winutil.h"
#include <string>
#include <vector>

//---------------------------------------------------------------------------

#pragma package(smart_init)

//---------------------------------------------------------------------------
// Language Functions:
//---------------------------------------------------------------------------

AnsiString English[] = {"English","Inactive", "Active", "Exit", "About","Options", "OK",
                        "Hotkey", "Cancel", "Start mode", "Last setting",
                        "Remove my settings from registry",
                        "Do you wish to remove all your settings from the registry?",
                        "Hotkey function","Remove formatting on hotkey",
                        "Toggle active/inactive",
                        "Remove leading and trailing whitespaces",
                        "Remove leading and trailing linebreaks",
                        "Always start with Windows",
                        "Apply filter",
                        "For online-help check the following website",
                        "Language", "Auto",
                        "Choose filter", "All links", "Picture links", "Movie links","Email addresses","Web links",
                        "Music links","FTP links","Archive links","Embedded pictures",
                        "General", "Filters","Add","Delete","Name","Wildcard / Regular Expression",
                        "Predefined field cannot be deleted",
                        "History", "Enable history", "Number of lines to show", "Milliseconds to show",
                        "Welcome to HovText",
                        "This message will only be shown once as it is the first time HovText starts up.\n\n"
                        "HovText is now active and will automaticaly removes formatting from all text in\n"
                        "the clipboard. You can see if HovText is active, by the little green square icon\n"
                        "in the right bottom corner of the screen.\n\n"
                        "We will on the following start up the options dialog , where you among others\n"
                        "can setup hotkeys and history etc.\n",
                        "Remove identical lines", "Filtering"
                        };


AnsiString Danish[] = {"Dansk","Inaktiv", "Aktiv", "Afslut", "Om HovText", "Indstillinger","OK",
                        "Genvejstast", "Annuller", "Start tilstand", "Sidste tilstand",
                        "Fjern mine indstillinger fra registreringsdatabasen",
                        "Vil du fjerne alle dine indstillinger fra registeringsdatabasen?",
                        "Genvejstast funktion", "Fjern formatering ved genvejstast",
                        "Skift mellem aktiv/inaktiv tilstand",
                        "Fjern mellemrum i start og slutning af teksten",
                        "Fjern linjeskift i start og slutning af teksten",
                        "Start automatisk sammen med Windows",
                        "Aktivr filter",
                        "For online-hjlp se nedenstende hjemmeside",
                        "Sprog", "Auto",
                        "Brug dette filter", "Alle links", "Billed links", "Film","Email adresser","Webside links","Musik links",
                        "FTP links","Links til komprimerede filer","Viste/indlejrede billeder p websiden",
                        "Generelt", "Filtre", "Tilfj", "Slet", "Navn", "Sgestreng / Regulrt udtryk",
                        "Prdefinerede felter kan ikke slettes",
                        "Historik", "Aktivr historik", "Vis antal linjer", "Visningstid i millisekunder",
                        "Velkommen til HovText",
                        "Denne besked vises kun denne ne gang, hvor HovText startes op for frste gang.\n\n"
                        "HovText er nu aktiv og vil automatisk fjerne formateringen fra alt tekst i udklipsholderen.\n"
                        "Du kan se, at HovText er aktiv ved, at der er et lille firkantet grnt ikon, nederst i\n"
                        "skrmens hjre hjrne.\n\n"
                        "Efterflgende vil vi starte op for HovTexts indstillinger, hvor du blandt andet kan\n"
                        "indstille genvejstaster og historik m.v.\n",
                        "Fjern identiske linier", "Filter"
                        };


AnsiString German[] = {"Deutsch", "Inaktiv","Aktiv", "Exit","ber","Wahl","OK",
                       "Schnelltaste","Abbrechen", "Startmodus","Vorige Einstellung",
                       "Meine Einstellungen von Datenbank lschen",
                       "Alle meine Einstellungen von Datenbank lschen? ",
                       "Schnelltasten-Funktion", "Remove formatting on hotkey",
                       "Schalten zwischen aktiv/inaktiv",
                       "Leerfelder vor und nach Text entfernen ",
                       "Zeilenumbruch vor und nach Text entfernen",
                       "Automatisch zusammen mit Windows starten",
                       "Nur Links kopieren",
                       "Fr Online-Hilfe sehen Sie bitte diese Website",
                       "Sprache", "Auto",
                       "Linktypen", "Alle", "Photos", "Film", "Email", "Web", "Musik", "FTP","Archivieren","Embedded pictures",
                       "Generell", "Linktypen", "Zufgen", "Lschen", "Titel", "Suchestring",
                       "Vordefinierte Felder knnen nicht gelscht werden",
                        "History", "Enable history", "Number of lines to show", "Milliseconds to show",
                        "Welcome to HovText",
                        "This message will only be shown once as it is the first time HovText starts up.\n\n"
                        "HovText is now active and will automaticaly removes formatting from all text in\n"
                        "the clipboard. You can see if HovText is active, by the little green square icon\n"
                        "in the right bottom corner of the screen.\n\n"
                        "We will on the following start up the options dialog , where you among others\n"
                        "can setup hotkeys and history etc.\n",
                        "Remove duplicate lines", "Filtering"
                       };



AnsiString Dutch[] = { "Nederlands", "Niet actief","Actief","Afsluiten","Over", "Opties","OK",
                       "Hotkey","Afbreken","Opstartmode","Laatste instelling",
                       "Verwijder mijn instellingen uit register",
                       "Wilt u al uw instellingen verwijderen uit het register?",
                       "Hotkey functie","Remove formatting on hotkey",
                       "Toggle actief/niet actief",
                       "Verwijder de spaties voor en na de tekst",
                       "Verwijder de witregels voor en na de tekst",
                       "Altijd starten met Windows",
                       "Copieer alleen links",
                       "Voor on-line help ga naar de volgende site",
                       "Kies een taal", "Auto",
                       "Linktype", "All", "Pictures", "Movies","Email","Web","Music","FTP","Archives","Embedded pictures",
                       "General", "Linktypes","Add","Delete","Name","Wildcard",
                       "Predefined field cannot be deleted",
                        "History", "Enable history", "Number of lines to show", "Milliseconds to show",
                        "Welcome to HovText",
                        "This message will only be shown once as it is the first time HovText starts up.\n\n"
                        "HovText is now active and will automaticaly removes formatting from all text in\n"
                        "the clipboard. You can see if HovText is active, by the little green square icon\n"
                        "in the right bottom corner of the screen.\n\n"
                        "We will on the following start up the options dialog , where you among others\n"
                        "can setup hotkeys and history etc.\n",
                        "Remove duplicate lines", "Filtering of links"
                       };


AnsiString French[] = { "Franais", "Dsactiv", "Activ", "Quitter", "A propos","Options", "OK",
                        "Raccourci clavier", "Annuler",
                      	"Mode au dmarrage", "Dernier paramtre", "Retirer mes paramtres du registre",
                        "Souhaitez-vous retirer tous vos paramtres du registre ?",
                        "Fonction du raccourci","Retirer le formatage sur utilisation raccourci","Activer/Dsactiver",
                        "Retirer les blancs en tte et en queue",
                        "Retirer les sauts de lignes en tte et en queue",
                        "Toujours lancer au dmarrage de Windows",
                        "Appliquer le filtre",
                        "Pour l'aide en ligne, allez  l'adresse suivante",
                        "Langage", "Auto",
                        "Choisissez le filtre", "Tous", "Images", "Films", "E-mail", "Web", "Musique","FTP","Archives","Images incorpores",
                        "Gnral", "Filtres", "Ajouter", "Effacer", "Nom", "Jokers / Expressions rgulires",
                        "Le champ prdfini ne peut pas tre effac",
                        "Historique", "Activer l'historique", "Nb de lignes  afficher", "Millisecondes pour afficher",
                        "Bienvenue dans HovText",
                        " Ce message ne sera affich qu'une fois car c'est la premire fois qu'HovText est lanc.\n\n"
                        "HovText est maintenant actif et retirera automatiquement le formatage de tout texte dans\n"
                        "le presse-papiers. Vous pouvez voir si HovText est actif avec la petite icne reprsentant\n"
                        "un petit carr vert dans le coin en bas  droite de l'cran.\n\n"
                        "Au prochain dmarrage la fentre des options sera affiche, fentre dans laquelle vous pouvez,\n"
                        "entre autres, dfinir les raccourcis clavier, l'historique, etc.\n",
                        "Retirer les lignes en doubles","Filtrage"

                        };

AnsiString Italian[] = { "Italiano", "Inattivo", "Attivo", "Esci", "Informazioni", "Opzioni", "OK", "Hotkey", "Annulla",
                         "Modalit d'avvio", "Ultime impostazioni", "Elimina le mie impostazioni dal registro",
                         "Desideri eliminare tutte le tue impostazioni dal registro?",
                         "Funzione della hotkey", "Remove formatting on hotkey", "Attiva/Disattiva",
                         "Elimina spazi iniziali e finali",
                         "Elimina a capo iniziali e finali",
                         "Esegui sempre all'avvio di Windows",
                         "Copia solo i link",
                         "Per l'aiuto online vai al seguente indirizzo" ,
                         "Lingua", "Auto",
                         "Tipo di link", "Tutti", "Immagini", "Film", "Email", "Web", "Musica", "FTP", "Archivi","Embedded pictures",
                         "Generali", "Tipi di link","Aggiungi", "Cancella", "Nome", "Estensioni",
                         "I campi predefiniti non possono essere cancellati",
                        "History", "Enable history", "Number of lines to show", "Milliseconds to show",
                        "Welcome to HovText",
                        "This message will only be shown once as it is the first time HovText starts up.\n\n"
                        "HovText is now active and will automaticaly removes formatting from all text in\n"
                        "the clipboard. You can see if HovText is active, by the little green square icon\n"
                        "in the right bottom corner of the screen.\n\n"
                        "We will on the following start up the options dialog , where you among others\n"
                        "can setup hotkeys and history etc.\n",
                        "Remove duplicate lines", "Filtering of links"


                       };
AnsiString Swedish[] = {"Svenska","Inaktiv", "Aktiv", "Avsluta", "Om","Instllningar", "OK",
                        "Kortkommando", "Avbryt", "Startlge", "Senaste instllning",
                        "Ta bort instllningar frn registret",
                        "Vill du ta bort alla instllningar frn registret?",
                        "Kortkommandoalternativ","Ta bort formatering vid snabbkommando",
                        "Skifta aktiv/inaktiv",
                        "Ta bort blanksteg i brjan och slutet",
                        "Ta bort radbrytningar i brjan och slutet",
                        "Autostart med Windows",
                        "Endast lnkar",
                        "Lnk fr onlinehjlp:",
                        "Sprk", "Auto",
                        "Lnktyp", "Alla", "Bilder", "Filmer", "E-post", "Web", "Musik", "FTP", "Arkiv","Inbddade bilder",
                        "Allmnt", "Lnktyper", "Lgg till", "Radera", "Namn", "Jokertecken / uttryck",
                        "Frdefinierade flt kan inte raderas",
                        "Historik", "Aktivera historik", "Visa antal rader", "Visa i millisekunder",
                        "Vlkommen till HovText",
                        "Detta meddelande visas en gng eftersom detta r den frsta gngen HovText startats.\n\n"
                        "HovText r nu aktiverat och tar automatiskt bort formatteringen frn all text i\n"
                        "urklippshanteraren. Du kan se om HovText r aktiv om du ser den lilla grna fyrkantiga\n"
                        "ikonen i det hgra hrnet av skrmen.\n\n"
                        "Du kommer nu att komma till instllningarna dr du bland annat\n"
                        "kan stlla in snabbkommandon och historik etc.\n",
                        "Ta bort dubbla rader", "Filtrering av lnkar"
                        };

AnsiString Norwegian[] = {"Norsk","Inaktiv", "Aktiv", "Avslutt", "Om HovText", "Innstillinger","OK",
                        "Hurtigtast", "Annuller", "Startmodus", "Siste innstilling",
                        "Fjern mine innstillinger fra registreringsdatabasen",
                        "Vil du fjerne alle dine innstillinger fra registeringsdatabasen?",
                        "Hurtigtastfunksjon", "Fjern formatering ved hurtigtast",
                        "Skift mellom aktiv/inaktiv tilstand",
                        "Fjern mellomrom i start og slutt av tekst",
                        "Fjern linjeskift i start og slutt av tekst",
                        "Start automatisk sammen med Windows",
                        "Aktivr filter",
                        "For online-hjelp, se nedenstende hjemmeside",
                        "Sprk", "Auto",
                        "Bruk dette filter", "Alle linker", "Bildelinker", "Film","Epostadresser","Websidelinker","Musikklinker",
                        "FTP-linker","Linker til komprimerte filer","Viste/innlagte bilder p websiden",
                        "Generelt", "Filtre", "Tilfje", "Slett", "Navn", "Skestreng / Regulre uttrykk",
                        "Predefinerte felter kan ikke slettes",
                        "Historikk", "Aktivr historikk", "Vis antall linjer", "Visningstid i millisekunder",
                        "Velkommen til HovText",
                        "Denne beskjeden vises kun denne ne gangen, nr HovText startes opp for frste gang.\n\n"
                        "HovText er n aktiv og vil automatisk fjerne formateringen fra all tekst i utklippstavlen.\n"
                        "Du kan se at HovText er aktiv ved at det er et lite firkantet grnt ikon nederst i\n"
                        "skjermens hyre hjrne.\n\n"
                        "Etter dette bildet vil HovTexts innstillinger starte opp. Der kan du blant annet \n"
                        "sette opp hurtigtaster, historikk osv.\n",
                        "Fjern identiske linjer", "Filter"
                        };

AnsiString Polish[] = { "Polski","Nieaktywny", "Aktywny", "Wyj?cie", "O...","Opcje", "OK",
                        "Skrty", "Anuluj", "Tryb Start", "Ustatnie ustawienie",
                        "Usun' moje ustawienia z rejestru",
                        "Czy usunc' wszystkie ustawienia z rejestru?",
                        "Funkcje skrtu","Usun' formaty skrtem",
                        "Prze?cz aktywny/nieaktywny",
                        "Usun' pocztkowe i kon'cowe znaki puste",
                        "Usun' pocztkowe i kon'cowe przej?cia do nowej linii",
                        "Zawsze startuj z Windowsem",
                        "Stosuj filtr",
                        "Pomocy online szukaj na stronie",
                        "Je;zyk", "Auto",
                        "Wybierz filtr", "Wszystkie linki", "Linki do grafiki", "Linki do filmw","Adresy e-mail","Linki sieci",
                        "Linki muzyczne","Linki FTP","Linki archiwalne","Osadzone grafiki",
                        "Oglne", "Filtry","Dodaj","Usun'","Nazwa","Znak uniwersalny / Wyraz.enie regularne",
                        "Predefiniowane pole nie moz.e byc' usunie;te",
                        "Historia", "W?cz historie;", "Ilo?c' lini do pokazania", "Millisekund do pokazania",
                        "Witamy w HovText",
                        "Ta wiadomo?c' be;dzie pokazana tylko raz, przy pierwszym uruchomieniu programu HovText.\n\n"
                        "HovText jest teraz aktywny i automatycznie usuwa formatowanie z ca?ego tekstu w schowku.\n"
                        "To czy HovText jest aktywny, moz.na poznac' po zielonej kwadratowej ikonce\n"
                        "w prawym dolnym rogu ekranu.\n\n"
                        "Uruchomimy teraz okno dialogowe, gdzie be;dzie moz.na, mie;dzy innymi, ustawic'\n"
                        "skrty klawiaturowe, historie; etc.\n",
                        "Usun' identyczne linie", "Filtrowanie"
                       };

WORD Name2LangId(AnsiString name)
{
  if (name==Danish[TE_LangName])       return LANG_DANISH;
  else if (name==German[TE_LangName])  return LANG_GERMAN;
  else if (name==Dutch[TE_LangName])   return LANG_DUTCH;
  else if (name==French[TE_LangName])  return LANG_FRENCH;
  else if (name==Italian[TE_LangName]) return LANG_ITALIAN;
  else if (name==Swedish[TE_LangName]) return LANG_SWEDISH;
  else if (name==English[TE_LangName]) return LANG_ENGLISH;
  else if (name==Norwegian[TE_LangName]) return LANG_NORWEGIAN;
  else if (name==Polish[TE_LangName]) return LANG_POLISH;

  else
    return 0;
}

short LangId2idx(WORD langid)
{
	switch(langid)
	{
	  case LANG_DANISH:    return 1;
	  case LANG_GERMAN:    return 2;
	  case LANG_ENGLISH:   return 3;
	  case LANG_FRENCH:    return 4;
	  case LANG_ITALIAN:   return 5;
	  case LANG_DUTCH:     return 6;
	  case LANG_SWEDISH:   return 7;
	  case LANG_NORWEGIAN: return 8;
    case LANG_POLISH:    return 9;
	  default:             return 0;
	}
}


AnsiString LangText(TextEnum t)
{
  WORD langid=LangId2idx(GetRegInt("Language"));
  if (langid<=0)
    langid=LangId2idx((char)GetUserDefaultLCID());

	switch(langid)
	{
	  case 1:  return Danish[t];
	  case 2:  return German[t];
	  case 4:  return French[t];
	  case 5:  return Italian[t];
	  case 6:  return Dutch[t];
    case 7:  return Swedish[t];
    case 8:  return Norwegian[t];
    case 9:  return Polish[t];
	  default: return English[t];
	}
}

const std::vector<AnsiString>& LangList()
{
  static std::vector<AnsiString> langlist;

  langlist.clear();
  langlist.push_back(Danish[TE_LangName]);
  langlist.push_back(German[TE_LangName]);
  langlist.push_back(English[TE_LangName]);
  langlist.push_back(French[TE_LangName]);
  langlist.push_back(Italian[TE_LangName]);
  langlist.push_back(Dutch[TE_LangName]);
  langlist.push_back(Swedish[TE_LangName]);
  langlist.push_back(Norwegian[TE_LangName]);
//  langlist.push_back(Polish[TE_LangName]);

  return langlist;

}

TLangNotifier LangNotifier;


void TLangNotifier::AddLangNotify(TLangChangeNotify *n)
{
  Clients.push_back(n);
}

void TLangNotifier::RemoveLangNotify(TLangChangeNotify *n)
{
}

void TLangNotifier::LangChange()                 
{
  for (std::vector <TLangChangeNotify *> ::iterator i =Clients.begin();
       i !=Clients.end(); i++)
     (*i)->LangChange();
}

