// THE HOVGAARD KLAN
// PROJECT: HOVTEXT
//---------------------------------------------------------------------------
// NOTES........ :
// The setup-dialog, reads & saves the settings from the registry.
// Uses the TLangChangeNotify to notify the rest of the program,
// when the user changes language.
//
//---------------------------------------------------------------------------
#ifndef setupH
#define setupH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Registry.hpp>
#include "lang.h"
#include <Grids.hpp>
#include <ValEdit.hpp>

//---------------------------------------------------------------------------
class TSetupForm : public TForm, public TLangChangeNotify
{
__published:	// IDE-managed Components
  TButton *OKButton;
  TButton *CancelButton;
  TPageControl *PageControl1;
  TTabSheet *TabGeneral;
  TTabSheet *TabLinkTypes;
  TLabel *LangLabel;
  TCheckBox *StripWSCheck;
  TCheckBox *StripCRRadio;
  TCheckBox *UninstallCheck;
  TGroupBox *HotkeyGroup;
  TLabel *HotkeyLabel;
  TRadioButton *ConvertRadio;
  THotKey *HotKey1;
  TRadioButton *ToggleRadio;
  TGroupBox *StartAsGroup;
  TRadioButton *ActiveRadio;
  TRadioButton *InactiveRadio;
  TRadioButton *LastRadio;
  TCheckBox *WindowsStartCheck;
  TComboBox *LangCombo;
  TValueListEditor *LinkTypeEditor;
  TLabel *HelpLabel;
  TLabel *URLLabel;
  TButton *AddButton;
  TButton *DeleteButton;
  TTabSheet *TabHistory;
  TCheckBox *ChkHistory;
  THotKey *HisHotKey;
  TLabel *LabelHisHotKey;
  TLabel *LabelHisLines;
  TComboBox *ComboHisLines;
  TLabel *LabelHisTime;
  TComboBox *ComboHisTime;
  TLabel *HelpLabel2;
  TLabel *URLLabel2;
  TCheckBox *UniqueLinesCheck;
  TGroupBox *LinkTypesGroup;
  TCheckBox *OnlyCopyLinksRadio;
  TLabel *LinkTypeLabel;
  TComboBox *LinkTypeCombo;
  void __fastcall FormShow(TObject *Sender);
  void __fastcall OKButtonClick(TObject *Sender);
  void __fastcall CancelButtonClick(TObject *Sender);
  void __fastcall UninstallCheckClick(TObject *Sender);
  void __fastcall URLLabelClick(TObject *Sender);
  void __fastcall LangComboChange(TObject *Sender);
  void __fastcall AddButtonClick(TObject *Sender);
  void __fastcall DeleteButtonClick(TObject *Sender);
  void __fastcall PageControl1Change(TObject *Sender);
private:	// User declarations
	void __fastcall SaveFiletypes();
	void __fastcall LoadFiletypes();
	void __fastcall UpdateFiletypes();
	void __fastcall Deinstall();
	void __fastcall DeinstallAll();
	void __fastcall DeinstallUser(TRegistry *Registry);
	WORD PrevLang;
	bool  UserUninstallOK;
  bool  NewFileTypes;
public:		// User declarations
	__fastcall TSetupForm(TComponent* Owner);
	virtual void LangChange();
};


//---------------------------------------------------------------------------
extern PACKAGE TSetupForm *SetupForm;
//---------------------------------------------------------------------------
#endif
